/*;  gridpoint.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.6 $$ {\rhead{\sl gridpoint.h\quad\thepage}} */
/*;  $$Date: 1997/03/01 21:26:25 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/gridpoint.h,v $$  */


#if !defined(gridpoint_h)
#define gridpoint_h

#include <iomanip>
#include <iostream>
#include "geometrc.h"
#include "nodeedge.h"
#include "dlist.h"
#include "dlist.cc"
#include "slist.h"

const int BpAtrbuteVal = 1; // Ρ(ή)°
const int LIMIT = 8;	    // ꥹȤϿ륨åκ

class QuadElmnt2d;

class GridPoint2d : public Point2d { // åɤĺ(2)饹
 protected:
  int quadNum;		// ȤĺˤʤäƤ룴շθĿ
  QuadElmnt2d* quadGroup[4];	// ȤĺˤʤäƤ룴շؤΥݥ
				//  
  int mGB;			// ʻҺɸ( x )
  int nGB;			// ʻҺɸ( y )
 public:
  GridPoint2d();	// default constructor
  GridPoint2d(const GridPoint2d& gp); // copy constructor
  GridPoint2d& operator= (const GridPoint2d& gp); // assignment operator
  int QuadNum() { return quadNum; }
  void SetQuadNum(int n) { quadNum = n; }
  QuadElmnt2d* QuadGroup(int i) { return quadGroup[i%4]; }
  void SetGridCoord(int mGBVal, int nGBVal) 
  { 
    mGB = mGBVal;  nGB = nGBVal; 
  }				     
  int MGB() { return mGB; }
  int NGB() { return nGB; }
  void AddQuad(QuadElmnt2d& qe);

  // ƥ
//  void Print(ostream& dst);
  void Print(ostream&);

};


class QuadElmnt2d {	// åɤĺˤ깽4շ饹
 protected:
  GridPoint2d* vd[4];	// շĺؤΥݥ
  int row;				// row  column ϣշ
  int column;			// row  column ˤ뤳Ȥ򼨤
  long nd;
 public:
  QuadElmnt2d() {}	// default construtor
  QuadElmnt2d(const QuadElmnt2d& q); // copy constructor
  QuadElmnt2d(GridPoint2d* p0, GridPoint2d* p1, GridPoint2d* p2,
    GridPoint2d* p3, int px, int py, long nVal = 0)
  {
    SetVal(p0, p1, p2, p3);
    row = px;  column = py; nd = nVal;
  }
  QuadElmnt2d& operator= (const QuadElmnt2d& q);
  void SetVal(GridPoint2d* p0, GridPoint2d* p1, GridPoint2d* p2,
    GridPoint2d* p3)
  {
    vd[0] = p0;  vd[1] = p1;  vd[2] = p2;  vd[3] = p3;
  }
  Line2d Side(int i);
  GridPoint2d* Vertex(int i) { return vd[i%4]; }
  long Number() { return nd; }
  void Number(long nVal) { nd = nVal; }
  int RowVal() { return row; }
  int ColumnVal() { return column; }
  void SetColumnRow(int x, int y) { row = x;  column = y; }
  GridPoint2d* Nearest(Point2d& p);
  Metric Area2();	// : շѤΣܤ
  int Inside(Point2d& p); // Pշˤ뤫ˤ뤫
			 // :
			 //  1: շ
			 //  0: շդξ
			 // -1: շγ
  void Print(ostream& dst);
};


class GridPoint3d : public Point3d { // åɤĺ(3)饹
 protected:
  DList<GridPoint3d*> cntgpp; // ΥåɥݥȤؤΥݥ󥿤Υ
			      // 
  int cntnum;		  // ΥåɥݥȤθĿ
  double area;		  // 
  int rivFlag;		  // 1: ƻ -1: ƻü 0: ƻ
			  // ʤ
  int edgeFlag;		  // 1: ޳Ԥü 0: ޳ԤüǤϤʤ
  
 public:
  GridPoint3d();	                          // default constructor
  GridPoint3d(const GridPoint3d& gp);		  // copy constructor
  ~GridPoint3d() { }				  // destructor
  GridPoint3d& operator= (const GridPoint3d& gp); // assignment operator
  int CntNum() { return cntnum; }
  void CntNum(int n) { cntnum = n; }
  DList<GridPoint3d*>& NeighborGp() { return cntgpp; }
  void ConnectGp(GridPoint3d* gpp);
  void CutGp(GridPoint3d* gpp);
  double Area() { return area; }
  void SetArea(double areaval) { area = areaval; }
  int RiverFlag() { return rivFlag; }
  void RiverFlag(int rivFlagVal) { rivFlag = rivFlagVal; }
  int EdgeFlag() { return edgeFlag; }
  void EdgeFlag(int edgeFlagVal) { edgeFlag = edgeFlagVal; }
    
  // ƥ
  void Print(ostream& dst);
};

class RiversidePoint0 {	// ƻή饹
 protected:
  int upmGB;		// ƻ׾¦γʻxɸ
  int upnGB;		// ƻ׾¦γʻyɸ
  int mGB;		// ʻxɸ
  int nGB;		// ʻyɸ
  int downmGB;		// ƻ׾¦γʻxɸ
  int downnGB;		// ƻ׾¦γʻyɸ
  GridPoint3d* gp;	// ƻή
  void Copy(const RiversidePoint0& rsp)
  {
    upmGB = rsp.upmGB; upnGB = rsp.upnGB; 
    mGB = rsp.mGB; nGB = rsp.nGB; 
    downmGB = rsp.downmGB; downnGB = rsp.downnGB;
    gp = rsp.gp;
  }
 public:
  RiversidePoint0()
  {
    upmGB = -1; upnGB = -1; 
    mGB = -1; nGB = -1; 
    downmGB = -1; downnGB = -1;
    gp = new GridPoint3d;
  }
  RiversidePoint0(const RiversidePoint0& rsp) { Copy(rsp); }
  ~RiversidePoint0() { delete gp; }
  RiversidePoint0& operator= (const RiversidePoint0& rsp)
  {
    if (this == &rsp) return *this;
    Copy(rsp);
    return *this;
  }
  void SetUpGCoord(int mval, int nval)
  { upmGB = mval; upnGB = nval; }
  void SetGCoord(int mval, int nval)
  { mGB = mval; nGB = nval; }
  void SetDownGCoord(int mval, int nval)
  { downmGB = mval; downnGB = nval; }
  int UpMGB() { return upmGB; }
  int UpNGB() { return upnGB; }
  int MGB() { return mGB; }
  int NGB() { return nGB; }
  int DownMGB() { return downmGB; }
  int DownNGB() { return downnGB; }
  GridPoint3d* Gpoint() { return gp; }
//   void SetGpNull() { gp = NULL; }

    // mod. by iYutaka (Tue Nov 12 19:24:23 2002)
    void SetGpNull()
    {
        delete gp; // 򤷤ʤȥ꡼
        gp = NULL;
    }

};

class BasinPoint3d : public BNode { // ή饹
 protected:
  BasinPoint3d** cntbp;   // ³줿ήؤΥݥ󥿤Υݥ
  int cntnum;		  // ³줿ήθĿ
  double area;		  // 
  int rsFlag;		  // 1: ƻή0: ƻήǤϤʤ
  DList<BasinPoint3d*> inList; // ήήؤ
			       // ݥ󥿤Υꥹ
  DList<BasinPoint3d*> outList; // ήήؤ
				// ݥ󥿤Υꥹ
  DList<BBEdge*> inEdgeList;
  DList<BBEdge*> outEdgeList;
  DList<BREdge*> rbEdgeList;
 public:
  BasinPoint3d();	                          // default constructor
  BasinPoint3d(const BasinPoint3d& bp);		  // copy constructor
  ~BasinPoint3d();				  // destructor
  BasinPoint3d& operator= (const BasinPoint3d& bp); // assignment operator
  void New(int sizeVal);
  int CntNumber() { return cntnum; }
  void CntNumber(int n) { cntnum = n; }
  BasinPoint3d* NeighborBp(int i) const { return cntbp[i%cntnum]; }
  void ConnectBp(int num, BasinPoint3d* bp);
  void CutBp(BasinPoint3d* bp);
  double Area() { return area; }
  void SetArea(double areaval) { area = areaval; }
  int RiversideFlag() { return rsFlag; }
  void RiversideFlag(int rsFlagVal) { rsFlag = rsFlagVal; }
  DList<BasinPoint3d*>& InList() { return inList; }
  DList<BasinPoint3d*>& OutList() { return outList; }
  DList<BBEdge*>& InEdgeList() { return inEdgeList; }
  DList<BBEdge*>& OutEdgeList() { return outEdgeList; }
  DList<BREdge*>& RbEdgeList() { return rbEdgeList; }
  int Attribute() { return BpAtrbuteVal; }

  // ƥ
  void Print(ostream& dst);

};

class BasinPoint : public BNode { // ή饹
 protected:
  SList<OldBBEdge*, LIMIT> inEdgeList; // ήή륨åΥꥹ
  SList<OldBBEdge*, LIMIT> outEdgeList;	// ήήФ륨åΥꥹ
					// 
  BREdge* rbEdge;			// ήƻåؤΥݥ
					// 
 public:
  BasinPoint() { rbEdge = NULL; } // default constructor
  BasinPoint(const BasinPoint& bp) // copy constructor
  {
    inEdgeList = bp.inEdgeList;
    outEdgeList = bp.outEdgeList;
    rbEdge = bp.rbEdge;
  }    
  BasinPoint& operator= (const BasinPoint& bp) // assignment operator
  {
    if (&bp == this) return *this;
    inEdgeList = bp.inEdgeList;
    outEdgeList = bp.outEdgeList;
    rbEdge = bp.rbEdge;
    return *this;
  }    
  SList<OldBBEdge*, LIMIT>& InEdgeList() { return inEdgeList; }
  SList<OldBBEdge*, LIMIT>& OutEdgeList() { return outEdgeList; }
  BREdge* RbEdge() { return rbEdge; }
  void SetRbEdge(BREdge* bre) { rbEdge = bre; }
  int Attribute() { return BpAtrbuteVal; }

  // ƥ
  void Print(ostream& dst);

};

#endif

/*; end of file */
