/*;  nodeedge.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl nodeedge.h\quad\thepage}} */
/*;  $$Date: 1997/03/06 06:36:49 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/nodeedge.h,v $$  */

#if !defined(nodeedge_h)
#define nodeedge_h

#include "geometrc.h"
#include "slist.h"
#include "slist.cc"

const int BBAtrbuteVal = 1; // å(ήή)°
const int BRAtrbuteVal = 2; // å(ήƻ)°
const int RRAtrbuteVal = 3; // å(ƻƻ)°

class NewBBEdge;

typedef SListDynamic<NewBBEdge*> BBEdgeList; 

class BNode : public Point3d { // Ρɴܥ饹
 public:
  BNode():Point3d() {}
  BNode(const BNode& bn):Point3d(bn) {}
  virtual ~BNode() {}
  virtual int Attribute() = 0;
};

class Edge {		// åܥ饹
 protected:
  long number;		// åֹ
  BNode* inNode;	// åΡ()
  BNode* outNode;	// åΡ()
			// (inNode) ---> (outNode)
 public:
  Edge() { inNode = NULL; outNode = NULL; }
  virtual ~Edge() {}
  BNode* InNode() { return inNode; }
  void SetInNode(BNode* inNodep) { inNode = inNodep; }
  BNode* OutNode() { return outNode; }
  void SetOutNode(BNode* outNodep) { outNode = outNodep; }
  long Number() { return number; }
  void Number(long nVal) { number = nVal; }
  virtual int Attribute() = 0;
};

class BBEdge : public Edge { // å(ήή)饹
 protected:
  double area;		// å
  double length;	// åĹ
 public:
  double Area() { return area; }
  void SetArea(double aVal) { area = aVal; }
  double Length() { return length; }
  void SetLength(double lVal) { length = lVal; }
  int Attribute() { return BBAtrbuteVal; }
};
/*
class NewBBEdge;

class BBEdgeList : public SListDynamic<NewBBEdge*> {
 protected:
  double totalarea;
 public:
  double TotalArea() { return totalarea; }
  void TotalArea(double aVal) { totalarea = aVal; }
};
*/

class OldBBEdge : public BBEdge {
 protected:
  int calcflag;
  SListDynamic<BBEdgeList*> slopelist;
//  SListDynamic<OldBBEdge*> upedgelist;
 public:
  OldBBEdge() { calcflag = 0; }
  void Del();
  ~OldBBEdge() { Del(); }
  SListDynamic<BBEdgeList*>& SlopeList() { return slopelist; }
//  SListDynamic<OldBBEdge*>& UpEdgeList() { return upedgelist; }
  int CalcFlag() { return calcflag; }
  void CalcFlag(int flagval) { calcflag = flagval; } 
};

class NewBBEdge {
 protected:
  OldBBEdge* oldedge;
  double area;		// å
//  double length;	// åĹ
 public:
  OldBBEdge* OldEdge() { return oldedge; }
  void SetOldEdge(OldBBEdge* oe) { oldedge = oe; } 
  double Area() { return area; }
  void SetArea(double aVal) { area = aVal; }
//  double Length() { return length; }
//  void SetLength(double lVal) { length = lVal; }
};
    
class BREdge : public Edge { // å(ήƻ)饹
 public:
  int Attribute() { return BRAtrbuteVal; }
};

class RREdge : public Edge { // å(ƻƻ)饹
 protected:
  double length;	// åĹ
 public:
  double Length() { return length; }
  void SetLength(double lVal) { length = lVal; }
  int Attribute() { return RRAtrbuteVal; }
};

#endif

/*; end of file */
