/*;  riverpoint.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl riverpoint.h\quad\thepage}} */
/*;  $$Date: 1997/02/01 16:14:29 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/riverpoint.h,v $$  */


#if !defined(riverpoint_h)
#define riverpoint_h

#include <iostream>
#include "nodeedge.h"
#include "dlist.h"
#include "dlist.cc"

using namespace std;   // added on Oct. 11, 2007

const int RpAtrbuteVal = 2; // Ρ(ƻ)°

class RiverPoint : public BNode { // ƻΥ饹
 protected:
  int rsegNum;		// ƻʬֹ
  int mGB;		// ʻҺɸ( x )
  int nGB;		// ʻҺɸ( y )
  DList<BREdge*> bpEdgeList; // å(ήƻ)ꥹ
  DList<RREdge*> rpinEdgeList; // ήå(ƻƻ)ꥹ
  DList<RREdge*> rpoutEdgeList;	// ήХå(ƻƻ)ꥹ
 public:
  RiverPoint():BNode() // default constructor
  {
    rsegNum = 0;  mGB = 0;  nGB = 0;
  }
  RiverPoint(const RiverPoint& rp):BNode(rp)  // copy constructor
  {
    rsegNum = rp.rsegNum;  mGB = rp.mGB;  nGB = rp.nGB;  
  }
  RiverPoint(Point3d p, int rsegNumVal = 0, int mGBVal = 0,
    int nGBVal = 0)
  {
	SetVal(p, rsegNumVal, mGBVal, nGBVal);
  }
  RiverPoint(Metric xVal, Metric yVal, ElvType zVal, int rsegNumVal = 0,
    int mGBVal = 0, int nGBVal = 0)
  {
    SetVal(xVal, yVal, zVal, rsegNumVal, mGBVal, nGBVal);
  }
  RiverPoint& operator= (const RiverPoint& rp) // assignment operator
  {
    if (&rp == this)  return *this;
	Point3d::operator=((Point3d)rp);
    rsegNum = rp.rsegNum;  mGB = rp.mGB;  nGB = rp.nGB;  
    return *this;
  }
  void SetVal(Point3d p, int rsegNumVal = 0, int mGBVal = 0,
    int nGBVal = 0)
  {
    xd = p.x();  yd = p.y();  zd = p.z();  nd = p.Number();
    rsegNum = rsegNumVal;
    mGB = mGBVal;  nGB = nGBVal;
  }
  void SetVal(Metric xVal, Metric yVal, ElvType zVal, int nVal,
    int rsegNumVal = 0, int mGBVal = 0, int nGBVal = 0)
  {
    xd = xVal;  yd = yVal;  zd = zVal;  nd = nVal;
    rsegNum = rsegNumVal;
    mGB = mGBVal;  nGB = nGBVal;
  }
  void SetGridCoord(int mGBVal, int nGBVal) 
  { 
    mGB = mGBVal;  nGB = nGBVal; 
  }				     
  void SetRsegNum(int rsegNumVal) { rsegNum = rsegNumVal; }
  int RsegNum() { return rsegNum; }
  int MGB() { return mGB; }
  int NGB() { return nGB; }
  void MGB(int amGB) { mGB = amGB; }
  void NGB(int anGB) { nGB = anGB; }
  int Attribute() { return RpAtrbuteVal; }
  DList<BREdge*>& BpEdgeList() { return bpEdgeList; }
  DList<RREdge*>& RpInEdgeList() { return rpinEdgeList; }
  DList<RREdge*>& RpOutEdgeList() { return rpoutEdgeList; }

  void Print(ostream& dst);
};

#endif

/*; end of file */
